


(* fabrique 100 listes de zéros de taille n par concaténation
   à gauche (i.e. Ln = [0] @ L(n-1))
   puis 100 listes de zéros de taille n par concaténation
   à droite (i.e. Ln = L(n-1) @ [0])
   et renvoie le couple (tg, td) de temps (en seconde) pris
   par chaque méthode en moyenne
    *)
let test (n: int) : float * float =
	let rec concat_droite n = 
		if n = 0 then []
		else concat_droite (n-1) @ [0]
	in
	let rec concat_gauche n = 
		if n = 0 then []
		else [0] @ concat_gauche (n-1)
	in
	(* temps moyen de calcul de 100 lancers de f sur n *)
	let avg f n =
		let start = Sys.time () in
		(* un peu d'avance sur le cours: on peut faire
		   des boucles for en OCaml *)
		for i = 0 to 99 do
			let _ = f n in () (* exécute f n *)
		done;
		let finish = Sys.time () in 
		finish -. start
	in 
	let tg, td = avg concat_gauche n, avg concat_droite n in 
	(tg /. 100., td /. 100.)


let temps_5000 = test 5000
(* on observe que le temps pris par la concaténation à
   gauche est bien plus court. Si on teste sur plusieurs
   valeurs, on observe que le temps de concaténation à gauche
   varie linéairement alors que le temps de concaténation à droite
   varie quadratiquement, ce qui est un bon signe que @ est bien
   linéaire en la taille de la première liste. *)